
module Test.API where

import Prelude
import Test.Hspec
import qualified Test.API.Authentication as Auth
import qualified Test.API.Errors as Errors
import qualified Test.API.Export as Export
import qualified Test.API.GraphQL as GraphQL
import qualified Test.API.Notifications as Notifications
import qualified Test.API.Private as Private
import qualified Test.API.UpdateList as UpdateList
import qualified Test.API.Worker as Worker

tests :: Spec
tests = describe "Gargantext API" $ do
  Auth.tests
  Private.tests
  GraphQL.tests
  Errors.tests
  Export.tests
  UpdateList.tests
  Notifications.tests
  Worker.tests
